/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.relatorios;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Radio;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.GrupoRuta;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioResumoLinhas;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioResumoLinhasAnalitico;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.GrupoRutaService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstandar;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;

/**
 * 
 * @author Administrador
 */
@Controller("relatorioResumoLinhasController")
@Scope("prototype")
public class RelatorioResumoLinhasController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;

	@Autowired
	private DataSource dataSourceRead;
	@Autowired
	private EmpresaService empresaService;
	@Autowired
	private RutaService rutaService;
	@Autowired
	private GrupoRutaService grupoRutaService;

	private List<Ruta> lsRuta;
	private List<Empresa> lsEmpresa;
	private List<GrupoRuta> lsGrupoRuta;

	private Datebox fecCorridaIni;
	private Datebox fecCorridaFin;
	private MyComboboxEstandar cmbRuta;
	private MyComboboxEstandar cmbEmpresa;
	private MyComboboxEstandar cmbGrupoRuta;
	private Radio rd1;

	public void onClick$btnExecutarRelatorio(Event ev) throws Exception {
		executarRelatorio();
	}

	/**
	 * @throws Exception
	 * 
	 */
	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void executarRelatorio() throws Exception {

		Relatorio relatorio;
		Map<String, Object> parametros = new HashMap<String, Object>();
		StringBuilder filtro = new StringBuilder();

		parametros.put("DATA_INICIAL", (java.util.Date) this.fecCorridaIni.getValue());
		parametros.put("DATA_FINAL", (java.util.Date) this.fecCorridaFin.getValue());
		parametros.put("NOME_RELATORIO", Labels.getLabel("relatorioResumoLinhasController.window.title"));
		parametros.put("USUARIO", UsuarioLogado.getUsuarioLogado().getUsuarioId().toString());

		Comboitem itemRuta = cmbRuta.getSelectedItem();

		filtro.append("Linha: ");
		if (itemRuta != null) {
			Ruta ruta = (Ruta) itemRuta.getValue();
			parametros.put("RUTA_ID", ruta.getRutaId());
			filtro.append(ruta.getDescruta() + ";");
		}
		else
			filtro.append("Todas;");

		Comboitem itemGrupoRuta = cmbGrupoRuta.getSelectedItem();

		filtro.append("Grupo de Linha: ");
		if (itemGrupoRuta != null) {
			GrupoRuta grupoRuta = (GrupoRuta) itemGrupoRuta.getValue();
			parametros.put("GRUPORUTA_ID", grupoRuta.getGrupoRutaId());
			filtro.append(grupoRuta.getDescGrupo());
		}
		else
			filtro.append("Todos;");

		Comboitem itemEmpresa = cmbEmpresa.getSelectedItem();
		if (itemEmpresa != null) {
			Empresa empresa = (Empresa) itemEmpresa.getValue();
			parametros.put("EMPRESA_ID", empresa.getEmpresaId());
			parametros.put("EMPRESA", empresa.getNombempresa());
		}

		parametros.put("FILTROS", filtro.toString());

		if (rd1.isChecked())
			relatorio = new RelatorioResumoLinhas(parametros, dataSourceRead.getConnection());
		else
			relatorio = new RelatorioResumoLinhasAnalitico(parametros, dataSourceRead.getConnection());

		Map args = new HashMap();
		args.put("relatorio", relatorio);

		openWindow("/component/reportView.zul",
				Labels.getLabel("relatorioResumoLinhasController.window.title"), args, MODAL);

	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		setLsRuta(rutaService.obtenerTodos());
		lsEmpresa = empresaService.obtenerTodos();
		lsGrupoRuta = grupoRutaService.obtenerTodos();

		super.doAfterCompose(comp);
	}

	public List<Ruta> getLsRuta() {
		return lsRuta;
	}

	public void setLsRuta(List<Ruta> lsRuta) {
		this.lsRuta = lsRuta;
	}

	public MyComboboxEstandar getCmbRuta() {
		return cmbRuta;
	}

	public void setCmbRuta(MyComboboxEstandar cmbRuta) {
		this.cmbRuta = cmbRuta;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public List<GrupoRuta> getLsGrupoRuta() {
		return lsGrupoRuta;
	}

	public void setLsGrupoRuta(List<GrupoRuta> lsGrupoRuta) {
		this.lsGrupoRuta = lsGrupoRuta;
	}

}
